#line 1 "C:/Documents and Settings/Administrator/My Documents/Programming/Mini-Sub/code/minisub_driver.c"
#line 1 "c:/documents and settings/administrator/my documents/programming/mini-sub/code/minisub_driver.h"
#line 1 "c:/documents and settings/administrator/my documents/programming/mini-sub/code/minisub_resources.h"
#line 9 "c:/documents and settings/administrator/my documents/programming/mini-sub/code/minisub_resources.h"
const code far char gameover_bmp[15558];
const code far char title_bmp[12503];
const code far char sub_bmp[3479];
const code far char mine_bmp[2543];
const code far char fireball_bmp[17938];
const code far char explode_bmp[4718];
const code far char torpedo_bmp[1008];
const code far char torpedo_pack_bmp[2543];
const code far char heart_bmp[2543];
const code far char torpedos_remain_bmp[1256];
const code far char lives_bmp[878];
#line 1 "c:/program files/mikroelektronika/mikroc pro for dspic/include/built_in.h"
#line 11 "c:/documents and settings/administrator/my documents/programming/mini-sub/code/minisub_driver.h"
char TFT_DataPort at LATA;
sbit TFT_RST at LATC1_bit;
sbit TFT_BLED at LATC2_bit;
sbit TFT_RS at LATB15_bit;
sbit TFT_CS at LATC3_bit;
sbit TFT_RD at LATD12_bit;
sbit TFT_WR at LATD13_bit;
char TFT_DataPort_Direction at TRISA;
sbit TFT_RST_Direction at TRISC1_bit;
sbit TFT_BLED_Direction at TRISC2_bit;
sbit TFT_RS_Direction at TRISB15_bit;
sbit TFT_CS_Direction at TRISC3_bit;
sbit TFT_RD_Direction at TRISD12_bit;
sbit TFT_WR_Direction at TRISD13_bit;



sbit DriveX_Left at LATB13_bit;
sbit DriveX_Right at LATB11_bit;
sbit DriveY_Up at LATB12_bit;
sbit DriveY_Down at LATB10_bit;
sbit DriveX_Left_Direction at TRISB13_bit;
sbit DriveX_Right_Direction at TRISB11_bit;
sbit DriveY_Up_Direction at TRISB12_bit;
sbit DriveY_Down_Direction at TRISB10_bit;
#line 1 "c:/program files/mikroelektronika/mikroc pro for dspic/include/built_in.h"
#line 13 "C:/Documents and Settings/Administrator/My Documents/Programming/Mini-Sub/code/minisub_driver.c"
void Set_Index(unsigned short index) {
 TFT_RS = 0;
  ((char *)&LATA)[0]  = index;
 TFT_WR = 0;
 TFT_WR = 1;
}


void Write_Command(unsigned short cmd) {
 TFT_RS = 1;
  ((char *)&LATA)[0]  = cmd;
 TFT_WR = 0;
 TFT_WR = 1;
}


void Write_Data(unsigned int _data) {
 TFT_RS = 1;
  ((char *)&LATE)[0]  =  ((char *)&_data)[1] ;
  ((char *)&LATA)[0]  =  ((char *)&_data)[0] ;
 TFT_WR = 0;
 TFT_WR = 1;
}


void Init_MCU() {

 TFT_DataPort_Direction = 0;
 CLKDIVbits.PLLPRE = 0;

 PLLFBD = 30;

 CLKDIVbits.PLLPOST = 0;

 Delay_ms(150);
 TFT_Set_Active(Set_Index,Write_Command,Write_Data);


 TFT_Init(320, 240);




 UART2_Init(256000);
 UART_Set_Active(UART2_Read, UART2_Write, UART2_Data_Ready, UART2_Tx_Idle);
 Delay_ms(100);


 TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
}
