
_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68

;minisub_main.c,76 :: 		void main() {
;minisub_main.c,77 :: 		TRISA = 0x0FFF;        // Bits 13-15 are outputs
	PUSH	W10
	MOV	#4095, W0
	MOV	WREG, TRISA
;minisub_main.c,78 :: 		TRISD = 0xFFFF;        // Initialize PORTD as input
	MOV	#65535, W0
	MOV	WREG, TRISD
;minisub_main.c,79 :: 		TRISB = 0x0000;        // Initialize PORTB as output
	CLR	TRISB
;minisub_main.c,80 :: 		TRISE = 0x000;
	CLR	TRISE
;minisub_main.c,83 :: 		TRISF.B1 = 1;
	BSET	TRISF, #1
;minisub_main.c,85 :: 		LATB  = 0xFF00;       //All leds off
	MOV	#65280, W0
	MOV	WREG, LATB
;minisub_main.c,88 :: 		Init_MCU();
	CALL	_Init_MCU
;minisub_main.c,91 :: 		file_loaded = 0;
	MOV	#lo_addr(_file_loaded), W1
	CLR	W0
	MOV.B	W0, [W1]
;minisub_main.c,92 :: 		Init_Sound();
	CALL	_Init_Sound
;minisub_main.c,93 :: 		MP3_Init();
	CALL	_MP3_Init
;minisub_main.c,96 :: 		UART2_Write_Text("Mini-Sub Game Started");
	MOV	#lo_addr(?lstr1_minisub_main), W10
	CALL	_UART2_Write_Text
;minisub_main.c,97 :: 		LATB  = 0x0000;      //All leds on
	CLR	LATB
;minisub_main.c,101 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,104 :: 		GetNextSong();
	CALL	_GetNextSong
;minisub_main.c,107 :: 		while(1){
L_main0:
;minisub_main.c,110 :: 		ResetGame();
	CALL	_ResetGame
;minisub_main.c,113 :: 		ShowTitles();
	CALL	_ShowTitles
;minisub_main.c,116 :: 		while(subLives){
L_main2:
	MOV	#lo_addr(_subLives), W0
	CP0	[W0]
	BRA NZ	L__main188
	GOTO	L_main3
L__main188:
;minisub_main.c,119 :: 		InitSprites();
	CALL	_InitSprites
;minisub_main.c,122 :: 		while (mineHit == 0) {
L_main4:
	MOV	_mineHit, W0
	CP	W0, #0
	BRA Z	L__main189
	GOTO	L_main5
L__main189:
;minisub_main.c,125 :: 		GetInput();
	CALL	_GetInput
;minisub_main.c,129 :: 		if(play_next_song){
	MOV	#lo_addr(_play_next_song), W0
	CP0	[W0]
	BRA NZ	L__main190
	GOTO	L_main6
L__main190:
;minisub_main.c,131 :: 		GetNextSong();
	CALL	_GetNextSong
;minisub_main.c,132 :: 		}
	GOTO	L_main7
L_main6:
;minisub_main.c,135 :: 		Play_MP3_Chunk();
	CALL	_Play_MP3_Chunk
;minisub_main.c,136 :: 		}
L_main7:
;minisub_main.c,139 :: 		RenderScreen();
	CALL	_RenderScreen
;minisub_main.c,142 :: 		SavePreviousVal();
	CALL	_SavePreviousVal
;minisub_main.c,145 :: 		frame_counter++;
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_frame_counter), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;minisub_main.c,147 :: 		} //end of the current sub life
	GOTO	L_main4
L_main5:
;minisub_main.c,150 :: 		mineHit = 0;
	CLR	W0
	MOV	W0, _mineHit
;minisub_main.c,153 :: 		mineExplode = 0;
	CLR	W0
	MOV	W0, _mineExplode
;minisub_main.c,156 :: 		subLives--;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	SUBR	W1, [W0], [W0]
;minisub_main.c,157 :: 		}
	GOTO	L_main2
L_main3:
;minisub_main.c,160 :: 		ShowGameOver();
	CALL	_ShowGameOver
;minisub_main.c,161 :: 		}
	GOTO	L_main0
;minisub_main.c,163 :: 		}
L_end_main:
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main

_ShowNextLevel:

;minisub_main.c,169 :: 		void ShowNextLevel(){
;minisub_main.c,170 :: 		int loop = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;minisub_main.c,173 :: 		if (prev_level != level){
	MOV	_prev_level, W1
	MOV	#lo_addr(_level), W0
	CP	W1, [W0]
	BRA NZ	L__ShowNextLevel193
	GOTO	L_ShowNextLevel8
L__ShowNextLevel193:
;minisub_main.c,176 :: 		UART2_Write_Text("Next Level: ");
	MOV	#lo_addr(?lstr2_minisub_main), W10
	CALL	_UART2_Write_Text
;minisub_main.c,177 :: 		UART2_Write_Variable(level);
	MOV	_level, W10
	CALL	_UART2_Write_Variable
;minisub_main.c,178 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,179 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,182 :: 		UART2_Write_Text("Score: ");
	MOV	#lo_addr(?lstr3_minisub_main), W10
	CALL	_UART2_Write_Text
;minisub_main.c,183 :: 		UART2_Write_Variable(score);
	MOV	_score, W10
	CALL	_UART2_Write_Variable
;minisub_main.c,184 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,185 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,188 :: 		UART2_Write_Text("Mine Speed: ");
	MOV	#lo_addr(?lstr4_minisub_main), W10
	CALL	_UART2_Write_Text
;minisub_main.c,189 :: 		UART2_Write_Variable(mine_speed);
	MOV	_mine_speed, W10
	CALL	_UART2_Write_Variable
;minisub_main.c,190 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,191 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,194 :: 		UART2_Write_Text("Bonus distance factor: ");
	MOV	#lo_addr(?lstr5_minisub_main), W10
	CALL	_UART2_Write_Text
;minisub_main.c,195 :: 		UART2_Write_Variable(bonus_factor);
	MOV	_bonus_factor, W10
	CALL	_UART2_Write_Variable
;minisub_main.c,196 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,197 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,200 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,203 :: 		TFT_Image(35, (SCREEN_HEIGHT/2)-47, title_bmp, 1);
	MOV	#lo_addr(_title_bmp), W0
	MOV	#higher_addr(_title_bmp), W1
	MOV.D	W0, W12
	MOV	#73, W11
	MOV	#35, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,206 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#___Lib_System_DefaultPage, W0
	MOV	W0, W11
	CALL	_TFT_Set_Font
;minisub_main.c,209 :: 		IntToStr(level, level_text);
	MOV	#lo_addr(_level_text), W11
	MOV	_level, W10
	CALL	_IntToStr
;minisub_main.c,210 :: 		strcpy(level_display_text, "Level: ");
	MOV	#lo_addr(?lstr6_minisub_main), W11
	MOV	#lo_addr(_level_display_text), W10
	CALL	_strcpy
;minisub_main.c,211 :: 		strcat(level_display_text, level_text);
	MOV	#lo_addr(_level_text), W11
	MOV	#lo_addr(_level_display_text), W10
	CALL	_strcat
;minisub_main.c,214 :: 		TFT_Write_Text(level_display_text, 140, 170);
	MOV	#170, W12
	MOV	#140, W11
	MOV	#lo_addr(_level_display_text), W10
	CALL	_TFT_Write_Text
;minisub_main.c,217 :: 		for(loop = 0; loop<=60;loop++){
; loop start address is: 2 (W1)
	CLR	W1
; loop end address is: 2 (W1)
L_ShowNextLevel9:
; loop start address is: 2 (W1)
	MOV	#60, W0
	CP	W1, W0
	BRA LE	L__ShowNextLevel194
	GOTO	L_ShowNextLevel10
L__ShowNextLevel194:
;minisub_main.c,218 :: 		Play_MP3_Chunk();
	PUSH	W1
	CALL	_Play_MP3_Chunk
	POP	W1
;minisub_main.c,219 :: 		Delay_ms(50);
	MOV	#9, W8
	MOV	#9047, W7
L_ShowNextLevel12:
	DEC	W7
	BRA NZ	L_ShowNextLevel12
	DEC	W8
	BRA NZ	L_ShowNextLevel12
;minisub_main.c,217 :: 		for(loop = 0; loop<=60;loop++){
	INC	W1
;minisub_main.c,220 :: 		}
; loop end address is: 2 (W1)
	GOTO	L_ShowNextLevel9
L_ShowNextLevel10:
;minisub_main.c,224 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,227 :: 		InitSprites();
	CALL	_InitSprites
;minisub_main.c,228 :: 		}
L_ShowNextLevel8:
;minisub_main.c,231 :: 		}
L_end_ShowNextLevel:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _ShowNextLevel

_ShowGameOver:

;minisub_main.c,239 :: 		void ShowGameOver(){
;minisub_main.c,240 :: 		int loop = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;minisub_main.c,242 :: 		UART2_Write_Line("Game Over");
	MOV	#lo_addr(?lstr7_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,245 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,248 :: 		TFT_Image(0, (SCREEN_HEIGHT/2)-47, GameOver_bmp, 1);
	MOV	#lo_addr(_gameover_bmp), W0
	MOV	#higher_addr(_gameover_bmp), W1
	MOV.D	W0, W12
	MOV	#73, W11
	CLR	W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,251 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#___Lib_System_DefaultPage, W0
	MOV	W0, W11
	CALL	_TFT_Set_Font
;minisub_main.c,255 :: 		if(score > high_score){
	MOV	_score, W1
	MOV	#lo_addr(_high_score), W0
	CP	W1, [W0]
	BRA GTU	L__ShowGameOver196
	GOTO	L_ShowGameOver14
L__ShowGameOver196:
;minisub_main.c,257 :: 		high_score = score;
	MOV	_score, W0
	MOV	W0, _high_score
;minisub_main.c,258 :: 		TFT_Write_Text("You  set  a  High  Score!", 100, 140);
	MOV	#140, W12
	MOV	#100, W11
	MOV	#lo_addr(?lstr8_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,259 :: 		}
	GOTO	L_ShowGameOver15
L_ShowGameOver14:
;minisub_main.c,264 :: 		IntToStr(high_score, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	_high_score, W10
	CALL	_IntToStr
;minisub_main.c,265 :: 		strcpy(score_display_text, "High  Score: ");
	MOV	#lo_addr(?lstr9_minisub_main), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcpy
;minisub_main.c,266 :: 		strcat(score_display_text, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcat
;minisub_main.c,269 :: 		TFT_Write_Text(score_display_text, 110, 140);
	MOV	#140, W12
	MOV	#110, W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_TFT_Write_Text
;minisub_main.c,270 :: 		}
L_ShowGameOver15:
;minisub_main.c,273 :: 		IntToStr(score, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	_score, W10
	CALL	_IntToStr
;minisub_main.c,274 :: 		strcpy(score_display_text, "Your  Score: ");
	MOV	#lo_addr(?lstr10_minisub_main), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcpy
;minisub_main.c,275 :: 		strcat(score_display_text, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcat
;minisub_main.c,278 :: 		TFT_Write_Text(score_display_text, 110, 170);
	MOV	#170, W12
	MOV	#110, W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_TFT_Write_Text
;minisub_main.c,281 :: 		for(loop = 0; loop<=60;loop++){
; loop start address is: 2 (W1)
	CLR	W1
; loop end address is: 2 (W1)
L_ShowGameOver16:
; loop start address is: 2 (W1)
	MOV	#60, W0
	CP	W1, W0
	BRA LE	L__ShowGameOver197
	GOTO	L_ShowGameOver17
L__ShowGameOver197:
;minisub_main.c,282 :: 		Play_MP3_Chunk();
	PUSH	W1
	CALL	_Play_MP3_Chunk
	POP	W1
;minisub_main.c,283 :: 		Delay_ms(50);
	MOV	#9, W8
	MOV	#9047, W7
L_ShowGameOver19:
	DEC	W7
	BRA NZ	L_ShowGameOver19
	DEC	W8
	BRA NZ	L_ShowGameOver19
;minisub_main.c,281 :: 		for(loop = 0; loop<=60;loop++){
	INC	W1
;minisub_main.c,284 :: 		}
; loop end address is: 2 (W1)
	GOTO	L_ShowGameOver16
L_ShowGameOver17:
;minisub_main.c,288 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,289 :: 		}
L_end_ShowGameOver:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _ShowGameOver

_ShowTitles:
	LNK	#2

;minisub_main.c,293 :: 		void ShowTitles(){
;minisub_main.c,294 :: 		int step_value = 10;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	MOV	#10, W0
	MOV	W0, [W14+0]
;minisub_main.c,297 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,300 :: 		TFT_Set_Brush(1, bgColor, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
	CLR	W13
	CLR	W12
	MOV	_bgColor, W11
	MOV	#1, W10
	CLR	W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;minisub_main.c,303 :: 		TFT_Image(35, (SCREEN_HEIGHT/2)-47, title_bmp, 1);
	MOV	#lo_addr(_title_bmp), W0
	MOV	#higher_addr(_title_bmp), W1
	MOV.D	W0, W12
	MOV	#73, W11
	MOV	#35, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,306 :: 		sub.y = 160;
	MOV	#160, W0
	MOV	W0, _sub+2
;minisub_main.c,309 :: 		for(sub.x = step_value+1;sub.x <= (SCREEN_WIDTH+1);sub.x+=step_value){
	MOV	[W14+0], W0
	INC	W0
	MOV	W0, _sub
L_ShowTitles21:
	MOV	_sub, W1
	MOV	#321, W0
	CP	W1, W0
	BRA LE	L__ShowTitles199
	GOTO	L_ShowTitles22
L__ShowTitles199:
;minisub_main.c,312 :: 		TFT_Image(sub.x, sub.y, sub_bmp, 1);
	MOV	#lo_addr(_sub_bmp), W0
	MOV	#higher_addr(_sub_bmp), W1
	MOV.D	W0, W12
	MOV	_sub+2, W11
	MOV	_sub, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,315 :: 		Play_MP3_Chunk();
	CALL	_Play_MP3_Chunk
;minisub_main.c,319 :: 		TFT_Rectangle(sub.x-step_value, sub.y, sub.x+step_value, sub.y + PLAYER_HEIGHT );
	MOV	#47, W1
	MOV	#lo_addr(_sub+2), W0
	ADD	W1, [W0], W3
	MOV	_sub, W1
	ADD	W14, #0, W0
	ADD	W1, [W0], W2
	MOV	_sub, W1
	ADD	W14, #0, W0
	SUB	W1, [W0], W0
	MOV	W3, W13
	MOV	W2, W12
	MOV	_sub+2, W11
	MOV	W0, W10
	CALL	_TFT_Rectangle
;minisub_main.c,322 :: 		frame_counter++;
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_frame_counter), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;minisub_main.c,309 :: 		for(sub.x = step_value+1;sub.x <= (SCREEN_WIDTH+1);sub.x+=step_value){
	MOV	_sub, W1
	ADD	W14, #0, W0
	ADD	W1, [W0], W0
	MOV	W0, _sub
;minisub_main.c,323 :: 		}
	GOTO	L_ShowTitles21
L_ShowTitles22:
;minisub_main.c,326 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,327 :: 		}
L_end_ShowTitles:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _ShowTitles

_GetInput:

;minisub_main.c,329 :: 		void GetInput()  {
;minisub_main.c,330 :: 		int mine_inc = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;minisub_main.c,331 :: 		int edge_border = 3;
; edge_border start address is: 4 (W2)
	MOV	#3, W2
;minisub_main.c,334 :: 		LED1 = 1;
	BSET	PORTA, #13
;minisub_main.c,336 :: 		if(startButton){
	BTSS	PORTF, #1
	GOTO	L_GetInput24
;minisub_main.c,340 :: 		LED1 = 0;
	BCLR	PORTA, #13
;minisub_main.c,341 :: 		}
L_GetInput24:
;minisub_main.c,343 :: 		if(upButton) {
	BTSS	PORTD, #14
	GOTO	L_GetInput25
;minisub_main.c,344 :: 		sub.y -= SUB_Y_SPEED;
	MOV	_sub+2, W0
	SUB	W0, #8, W0
	MOV	W0, _sub+2
;minisub_main.c,348 :: 		LED1 = 0;
	BCLR	PORTA, #13
;minisub_main.c,349 :: 		}
	GOTO	L_GetInput26
L_GetInput25:
;minisub_main.c,350 :: 		else if(downButton){
	BTSS	PORTD, #15
	GOTO	L_GetInput27
;minisub_main.c,351 :: 		sub.y += SUB_Y_SPEED;
	MOV	_sub+2, W0
	ADD	W0, #8, W0
	MOV	W0, _sub+2
;minisub_main.c,355 :: 		LED1 = 0;
	BCLR	PORTA, #13
;minisub_main.c,356 :: 		}
	GOTO	L_GetInput28
L_GetInput27:
;minisub_main.c,357 :: 		else if(leftButton) {
	BTSS	PORTD, #9
	GOTO	L_GetInput29
;minisub_main.c,358 :: 		sub.x -= SUB_SPEED;
	MOV	_sub, W0
	SUB	W0, #12, W0
	MOV	W0, _sub
;minisub_main.c,362 :: 		LED1 = 0;
	BCLR	PORTA, #13
;minisub_main.c,363 :: 		}
	GOTO	L_GetInput30
L_GetInput29:
;minisub_main.c,364 :: 		else if(rightButton){
	BTSS	PORTD, #6
	GOTO	L_GetInput31
;minisub_main.c,365 :: 		sub.x += SUB_SPEED;
	MOV	_sub, W0
	ADD	W0, #12, W0
	MOV	W0, _sub
;minisub_main.c,369 :: 		LED1 = 0;
	BCLR	PORTA, #13
;minisub_main.c,370 :: 		}
	GOTO	L_GetInput32
L_GetInput31:
;minisub_main.c,374 :: 		if( (frame_counter % 2) == 0){
	PUSH	W2
	MOV	#2, W2
	MOV	#0, W3
	MOV	_frame_counter, W0
	MOV	_frame_counter+2, W1
	SETM	W4
	CALL	__Modulus_32x32
	POP	W2
	CP	W0, #0
	CPB	W1, #0
	BRA Z	L__GetInput201
	GOTO	L_GetInput33
L__GetInput201:
;minisub_main.c,376 :: 		if(sub.x > DEFAULT_SUB_X_POS){
	MOV	_sub, W0
	CP	W0, #28
	BRA GT	L__GetInput202
	GOTO	L_GetInput34
L__GetInput202:
;minisub_main.c,377 :: 		sub.x -= 1;
	MOV	_sub, W0
	DEC	W0
	MOV	W0, _sub
;minisub_main.c,378 :: 		}
L_GetInput34:
;minisub_main.c,379 :: 		}
L_GetInput33:
;minisub_main.c,382 :: 		if( (frame_counter % 4) == 0){
	PUSH	W2
	MOV	#4, W2
	MOV	#0, W3
	MOV	_frame_counter, W0
	MOV	_frame_counter+2, W1
	SETM	W4
	CALL	__Modulus_32x32
	POP	W2
	CP	W0, #0
	CPB	W1, #0
	BRA Z	L__GetInput203
	GOTO	L_GetInput35
L__GetInput203:
;minisub_main.c,384 :: 		if(sub.x < DEFAULT_SUB_X_POS){
	MOV	_sub, W0
	CP	W0, #28
	BRA LT	L__GetInput204
	GOTO	L_GetInput36
L__GetInput204:
;minisub_main.c,385 :: 		sub.x += 1;
	MOV	_sub, W0
	INC	W0
	MOV	W0, _sub
;minisub_main.c,386 :: 		}
L_GetInput36:
;minisub_main.c,387 :: 		}
L_GetInput35:
;minisub_main.c,389 :: 		}
L_GetInput32:
L_GetInput30:
L_GetInput28:
L_GetInput26:
;minisub_main.c,393 :: 		if( sub.y <= STATUS_TEXT_CELL_HEIGHT ){
	MOV	_sub+2, W0
	CP	W0, #25
	BRA LE	L__GetInput205
	GOTO	L_GetInput37
L__GetInput205:
;minisub_main.c,394 :: 		sub.y = STATUS_TEXT_CELL_HEIGHT;
	MOV	#25, W0
	MOV	W0, _sub+2
;minisub_main.c,395 :: 		}
L_GetInput37:
;minisub_main.c,398 :: 		if( sub.x <= 0 ){
	MOV	_sub, W0
	CP	W0, #0
	BRA LE	L__GetInput206
	GOTO	L_GetInput38
L__GetInput206:
;minisub_main.c,399 :: 		sub.x = 0;
	CLR	W0
	MOV	W0, _sub
;minisub_main.c,400 :: 		}
L_GetInput38:
;minisub_main.c,403 :: 		if( sub.y >= (SCREEN_HEIGHT-PLAYER_HEIGHT)){
	MOV	#193, W1
	MOV	#lo_addr(_sub+2), W0
	CP	W1, [W0]
	BRA LE	L__GetInput207
	GOTO	L_GetInput39
L__GetInput207:
;minisub_main.c,404 :: 		sub.y = SCREEN_HEIGHT-PLAYER_HEIGHT;
	MOV	#193, W0
	MOV	W0, _sub+2
;minisub_main.c,405 :: 		}
L_GetInput39:
;minisub_main.c,408 :: 		if( sub.x >= (SCREEN_WIDTH-PLAYER_WIDTH)){
	MOV	_sub, W1
	MOV	#257, W0
	CP	W1, W0
	BRA GE	L__GetInput208
	GOTO	L_GetInput40
L__GetInput208:
;minisub_main.c,409 :: 		sub.x = SCREEN_WIDTH-PLAYER_WIDTH;
	MOV	#257, W0
	MOV	W0, _sub
;minisub_main.c,410 :: 		}
L_GetInput40:
;minisub_main.c,413 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
; mine_inc start address is: 14 (W7)
	CLR	W7
; edge_border end address is: 4 (W2)
; mine_inc end address is: 14 (W7)
	MOV	W2, W6
L_GetInput41:
; mine_inc start address is: 14 (W7)
; edge_border start address is: 12 (W6)
	CP	W7, #3
	BRA LE	L__GetInput209
	GOTO	L_GetInput42
L__GetInput209:
;minisub_main.c,416 :: 		if( mine[mine_inc].x <= edge_border){
	MOV	#14, W0
	MUL.UU	W0, W7, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #4, W0
	MOV	[W0], W0
	CP	W0, W6
	BRA LE	L__GetInput210
	GOTO	L_GetInput44
L__GetInput210:
;minisub_main.c,419 :: 		ResetSeaMine(mine_inc);
	MOV	W7, W10
	CALL	_ResetSeaMine
;minisub_main.c,422 :: 		TFT_Rectangle( mine[mine_inc].prev_x-1, mine[mine_inc].prev_y-1, mine[mine_inc].prev_x + mine[mine_inc].width + 1, mine[mine_inc].prev_y + mine[mine_inc].height + 1);
	MOV	#14, W0
	MUL.UU	W0, W7, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W4
	ADD	W4, #10, W0
	MOV	[W0], W1
	ADD	W4, #2, W0
	ADD	W1, [W0], W0
	ADD	W0, #1, W5
	ADD	W4, #8, W0
	MOV	[W0], W3
	MOV	[W4], W0
	ADD	W3, W0, W0
	ADD	W0, #1, W2
	DEC	W1
	SUB	W3, #1, W0
	PUSH.D	W6
	MOV	W5, W13
	MOV	W2, W12
	MOV	W1, W11
	MOV	W0, W10
	CALL	_TFT_Rectangle
	POP.D	W6
;minisub_main.c,425 :: 		score += 25;
	MOV	#25, W1
	MOV	#lo_addr(_score), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,426 :: 		}
	GOTO	L_GetInput45
L_GetInput44:
;minisub_main.c,429 :: 		mine[mine_inc].x -= mine_speed;
	MOV	#14, W0
	MUL.UU	W0, W7, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #4, W2
	MOV	[W2], W1
	MOV	#lo_addr(_mine_speed), W0
	SUB	W1, [W0], [W2]
;minisub_main.c,430 :: 		}
L_GetInput45:
;minisub_main.c,413 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	INC	W7
;minisub_main.c,432 :: 		}
; mine_inc end address is: 14 (W7)
	GOTO	L_GetInput41
L_GetInput42:
;minisub_main.c,435 :: 		if(bonus_block.x<=edge_border){
	MOV	#lo_addr(_bonus_block+4), W0
	CP	W6, [W0]
	BRA GE	L__GetInput211
	GOTO	L_GetInput46
L__GetInput211:
; edge_border end address is: 12 (W6)
;minisub_main.c,438 :: 		TFT_Rectangle( bonus_block.prev_x-1, bonus_block.prev_y-1, bonus_block.prev_x + bonus_block.width + 1, bonus_block.prev_y + bonus_block.height + 1);
	MOV	_bonus_block+10, W1
	MOV	#lo_addr(_bonus_block+2), W0
	ADD	W1, [W0], W0
	ADD	W0, #1, W3
	MOV	_bonus_block+8, W1
	MOV	#lo_addr(_bonus_block), W0
	ADD	W1, [W0], W0
	ADD	W0, #1, W2
	MOV	_bonus_block+10, W0
	SUB	W0, #1, W1
	MOV	_bonus_block+8, W0
	DEC	W0
	MOV	W3, W13
	MOV	W2, W12
	MOV	W1, W11
	MOV	W0, W10
	CALL	_TFT_Rectangle
;minisub_main.c,441 :: 		ResetBonusBlock();
	CALL	_ResetBonusBlock
;minisub_main.c,442 :: 		}
L_GetInput46:
;minisub_main.c,446 :: 		bonus_block.x -= mine_speed;
	MOV	_bonus_block+4, W1
	MOV	#lo_addr(_mine_speed), W0
	SUB	W1, [W0], W0
	MOV	W0, _bonus_block+4
;minisub_main.c,450 :: 		if(torpedoButton){
	BTSS	PORTD, #7
	GOTO	L_GetInput47
;minisub_main.c,452 :: 		UART2_Write_Line("Fire");
	MOV	#lo_addr(?lstr11_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,455 :: 		LED1 = 0;
	BCLR	PORTA, #13
;minisub_main.c,457 :: 		if(torpedo_count>=1) {
	MOV	_torpedo_count, W0
	CP	W0, #1
	BRA GE	L__GetInput212
	GOTO	L_GetInput48
L__GetInput212:
;minisub_main.c,459 :: 		if( fire_torpedo_flag == 0 ) {
	MOV	_fire_torpedo_flag, W0
	CP	W0, #0
	BRA Z	L__GetInput213
	GOTO	L_GetInput49
L__GetInput213:
;minisub_main.c,461 :: 		torpedo.x = sub.x + PLAYER_WIDTH + 1;
	MOV	#63, W1
	MOV	#lo_addr(_sub), W0
	ADD	W1, [W0], W0
	INC	W0
	MOV	W0, _torpedo+4
;minisub_main.c,464 :: 		torpedo.y = sub.y + (PLAYER_HEIGHT/2);
	MOV	_sub+2, W0
	ADD	W0, #23, W0
	MOV	W0, _torpedo+6
;minisub_main.c,467 :: 		torpedo.visible = 1;
	MOV	#1, W0
	MOV	W0, _torpedo+12
;minisub_main.c,470 :: 		fire_torpedo_flag = 1;
	MOV	#1, W0
	MOV	W0, _fire_torpedo_flag
;minisub_main.c,473 :: 		torpedo_count--;
	MOV	#1, W1
	MOV	#lo_addr(_torpedo_count), W0
	SUBR	W1, [W0], [W0]
;minisub_main.c,475 :: 		}
L_GetInput49:
;minisub_main.c,476 :: 		}
L_GetInput48:
;minisub_main.c,478 :: 		}
L_GetInput47:
;minisub_main.c,482 :: 		if( fire_torpedo_flag == 1 ){
	MOV	_fire_torpedo_flag, W0
	CP	W0, #1
	BRA Z	L__GetInput214
	GOTO	L_GetInput50
L__GetInput214:
;minisub_main.c,483 :: 		torpedo.x += TORPEDO_SPEED;
	MOV	_torpedo+4, W0
	ADD	W0, #12, W1
	MOV	W1, _torpedo+4
;minisub_main.c,486 :: 		if( torpedo.x > (SCREEN_WIDTH+TORPEDO_SPEED+1) ){
	MOV	#333, W0
	CP	W1, W0
	BRA GT	L__GetInput215
	GOTO	L_GetInput51
L__GetInput215:
;minisub_main.c,488 :: 		torpedo.visible = 0;
	CLR	W0
	MOV	W0, _torpedo+12
;minisub_main.c,490 :: 		fire_torpedo_flag = 0;
	CLR	W0
	MOV	W0, _fire_torpedo_flag
;minisub_main.c,491 :: 		}
L_GetInput51:
;minisub_main.c,493 :: 		}
L_GetInput50:
;minisub_main.c,497 :: 		} //end of MoveSub
L_end_GetInput:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _GetInput

_RandomHeightY:

;minisub_main.c,500 :: 		int RandomHeightY(){
;minisub_main.c,501 :: 		return (rand() % 6) * ((SCREEN_HEIGHT-STATUS_TEXT_CELL_HEIGHT)/6) + STATUS_TEXT_CELL_HEIGHT;
	CALL	_rand
	MOV	#6, W2
	REPEAT	#17
	DIV.S	W0, W2
	MOV	#35, W0
	MUL.SS	W1, W0, W0
	ADD	W0, #25, W0
;minisub_main.c,502 :: 		}
L_end_RandomHeightY:
	RETURN
; end of _RandomHeightY

_ResetBonusBlock:

;minisub_main.c,505 :: 		void ResetBonusBlock(){
;minisub_main.c,509 :: 		bonus_block.x = SCREEN_WIDTH*(BONUS_SCREEN_SPACING*bonus_factor);
	MOV	_bonus_factor, W0
	SL	W0, #1, W1
	MOV	#320, W0
	MUL.SS	W0, W1, W0
	MOV	W0, _bonus_block+4
;minisub_main.c,511 :: 		bonus_block.y = RandomHeightY();
	CALL	_RandomHeightY
	MOV	W0, _bonus_block+6
;minisub_main.c,514 :: 		bonus_counter += 1;
	MOV	#1, W1
	MOV	#lo_addr(_bonus_counter), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,519 :: 		if( (rand() % 3) == 0){
	CALL	_rand
	MOV	#3, W2
	REPEAT	#17
	DIV.S	W0, W2
	MOV	W1, W0
	CP	W0, #0
	BRA Z	L__ResetBonusBlock218
	GOTO	L_ResetBonusBlock52
L__ResetBonusBlock218:
;minisub_main.c,521 :: 		bonus_type = 2;
	MOV	#2, W0
	MOV	W0, _bonus_type
;minisub_main.c,522 :: 		}
	GOTO	L_ResetBonusBlock53
L_ResetBonusBlock52:
;minisub_main.c,525 :: 		bonus_type = 1;
	MOV	#1, W0
	MOV	W0, _bonus_type
;minisub_main.c,526 :: 		}
L_ResetBonusBlock53:
;minisub_main.c,527 :: 		}
L_end_ResetBonusBlock:
	RETURN
; end of _ResetBonusBlock

_ResetSeaMine:
	LNK	#2

;minisub_main.c,529 :: 		void ResetSeaMine(int mineNumber){
;minisub_main.c,532 :: 		mine[mineNumber].x += SCREEN_WIDTH;
	MOV	#14, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #4, W2
	MOV	[W2], W1
	MOV	#320, W0
	ADD	W1, W0, [W2]
;minisub_main.c,533 :: 		mine[mineNumber].y = RandomHeightY();
	MOV	#14, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W0
	MOV	W0, [W14+0]
	CALL	_RandomHeightY
	MOV	[W14+0], W1
	MOV	W0, [W1]
;minisub_main.c,534 :: 		}
L_end_ResetSeaMine:
	ULNK
	RETURN
; end of _ResetSeaMine

_UART2_Write_Line:

;minisub_main.c,538 :: 		void UART2_Write_Line(char *uart_text) {
;minisub_main.c,539 :: 		UART2_Write_Text(uart_text);
	PUSH	W10
	CALL	_UART2_Write_Text
;minisub_main.c,540 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,541 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,542 :: 		}
L_end_UART2_Write_Line:
	POP	W10
	RETURN
; end of _UART2_Write_Line

_UART2_Write_Variable:
	LNK	#12

;minisub_main.c,545 :: 		void UART2_Write_Variable(int var) {
;minisub_main.c,547 :: 		IntToStr(var, var_txt);
	PUSH	W10
	PUSH	W11
	ADD	W14, #0, W0
	MOV	W0, W11
	CALL	_IntToStr
;minisub_main.c,548 :: 		UART2_Write_Text(var_txt);
	ADD	W14, #0, W0
	MOV	W0, W10
	CALL	_UART2_Write_Text
;minisub_main.c,549 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,550 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,551 :: 		}
L_end_UART2_Write_Variable:
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _UART2_Write_Variable

_UART2_Write_Long_Variable:
	LNK	#20

;minisub_main.c,554 :: 		void UART2_Write_Long_Variable(long var){
;minisub_main.c,556 :: 		LongWordToStr(var, var_txt);
	PUSH	W10
	PUSH	W11
	PUSH	W12
	ADD	W14, #0, W0
	MOV	W0, W12
	CALL	_LongWordToStr
;minisub_main.c,557 :: 		UART2_Write_Text(var_txt);
	ADD	W14, #0, W0
	MOV	W0, W10
	CALL	_UART2_Write_Text
;minisub_main.c,558 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,559 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,560 :: 		}
L_end_UART2_Write_Long_Variable:
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _UART2_Write_Long_Variable

_RenderScreen:

;minisub_main.c,565 :: 		void RenderScreen(){
;minisub_main.c,566 :: 		int mine_inc = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;minisub_main.c,569 :: 		int redraw_border = 3;
;minisub_main.c,572 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
; mine_inc start address is: 12 (W6)
	CLR	W6
; mine_inc end address is: 12 (W6)
L_RenderScreen54:
; mine_inc start address is: 12 (W6)
	CP	W6, #3
	BRA LE	L__RenderScreen224
	GOTO	L_RenderScreen55
L__RenderScreen224:
;minisub_main.c,574 :: 		clear_mine[mine_inc].top =  mine[mine_inc].prev_y;
	SL	W6, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	MOV	W0, W1
	MOV	#14, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W0
	MOV	[W0], [W1]
;minisub_main.c,575 :: 		if(clear_mine[mine_inc].top < 0)
	SL	W6, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	MOV	[W0], W0
	CP	W0, #0
	BRA LT	L__RenderScreen225
	GOTO	L_RenderScreen57
L__RenderScreen225:
;minisub_main.c,576 :: 		clear_mine[mine_inc].top = 0;
	SL	W6, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W1
	CLR	W0
	MOV	W0, [W1]
L_RenderScreen57:
;minisub_main.c,578 :: 		clear_mine[mine_inc].left =  mine[mine_inc].x + mine[mine_inc].width;
	SL	W6, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #2, W5
	MOV	#14, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W4
	ADD	W4, #4, W0
	MOV	[W0], W1
	MOV	[W4], W0
	ADD	W1, W0, [W5]
;minisub_main.c,579 :: 		if(clear_mine[mine_inc].left < 0)
	SL	W6, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	INC2	W0
	MOV	[W0], W0
	CP	W0, #0
	BRA LT	L__RenderScreen226
	GOTO	L_RenderScreen58
L__RenderScreen226:
;minisub_main.c,580 :: 		clear_mine[mine_inc].left = 0;
	SL	W6, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #2, W1
	CLR	W0
	MOV	W0, [W1]
L_RenderScreen58:
;minisub_main.c,582 :: 		clear_mine[mine_inc].right = mine[mine_inc].prev_x + mine[mine_inc].width;
	SL	W6, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #6, W5
	MOV	#14, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W4
	ADD	W4, #8, W0
	MOV	[W0], W1
	MOV	[W4], W0
	ADD	W1, W0, [W5]
;minisub_main.c,583 :: 		if(clear_mine[mine_inc].right < 0)
	SL	W6, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #6, W0
	MOV	[W0], W0
	CP	W0, #0
	BRA LT	L__RenderScreen227
	GOTO	L_RenderScreen59
L__RenderScreen227:
;minisub_main.c,584 :: 		clear_mine[mine_inc].right = 0;
	SL	W6, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #6, W1
	CLR	W0
	MOV	W0, [W1]
L_RenderScreen59:
;minisub_main.c,586 :: 		clear_mine[mine_inc].bottom = mine[mine_inc].prev_y + mine[mine_inc].height;
	SL	W6, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #4, W5
	MOV	#14, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W4
	ADD	W4, #10, W0
	MOV	[W0], W1
	ADD	W4, #2, W0
	ADD	W1, [W0], [W5]
;minisub_main.c,587 :: 		if(clear_mine[mine_inc].bottom < 0)
	SL	W6, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #4, W0
	MOV	[W0], W0
	CP	W0, #0
	BRA LT	L__RenderScreen228
	GOTO	L_RenderScreen60
L__RenderScreen228:
;minisub_main.c,588 :: 		clear_mine[mine_inc].bottom = 0;
	SL	W6, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #4, W1
	CLR	W0
	MOV	W0, [W1]
L_RenderScreen60:
;minisub_main.c,572 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	INC	W6
;minisub_main.c,590 :: 		}
; mine_inc end address is: 12 (W6)
	GOTO	L_RenderScreen54
L_RenderScreen55:
;minisub_main.c,593 :: 		if(sub.x > sub.prev_x){
	MOV	_sub, W1
	MOV	#lo_addr(_sub+4), W0
	CP	W1, [W0]
	BRA GT	L__RenderScreen229
	GOTO	L_RenderScreen61
L__RenderScreen229:
;minisub_main.c,594 :: 		clear_sub.left = sub.prev_x;
	MOV	_sub+4, W0
	MOV	W0, _clear_sub+2
;minisub_main.c,595 :: 		clear_sub.right =  sub.x;
	MOV	_sub, W0
	MOV	W0, _clear_sub+6
;minisub_main.c,596 :: 		clear_sub.top = sub.y;
	MOV	_sub+2, W0
	MOV	W0, _clear_sub
;minisub_main.c,597 :: 		clear_sub.bottom = sub.y + PLAYER_HEIGHT;
	MOV	#47, W1
	MOV	#lo_addr(_sub+2), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+4
;minisub_main.c,598 :: 		}
L_RenderScreen61:
;minisub_main.c,601 :: 		if(sub.x < sub.prev_x){
	MOV	_sub, W1
	MOV	#lo_addr(_sub+4), W0
	CP	W1, [W0]
	BRA LT	L__RenderScreen230
	GOTO	L_RenderScreen62
L__RenderScreen230:
;minisub_main.c,602 :: 		clear_sub.left = sub.x+PLAYER_WIDTH;
	MOV	#63, W1
	MOV	#lo_addr(_sub), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+2
;minisub_main.c,603 :: 		clear_sub.right = sub.prev_x+PLAYER_WIDTH;
	MOV	#63, W1
	MOV	#lo_addr(_sub+4), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+6
;minisub_main.c,604 :: 		clear_sub.top = sub.y;
	MOV	_sub+2, W0
	MOV	W0, _clear_sub
;minisub_main.c,605 :: 		clear_sub.bottom = sub.y + PLAYER_HEIGHT;
	MOV	#47, W1
	MOV	#lo_addr(_sub+2), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+4
;minisub_main.c,606 :: 		}
L_RenderScreen62:
;minisub_main.c,610 :: 		if(sub.y > sub.prev_y){
	MOV	_sub+2, W1
	MOV	#lo_addr(_sub+6), W0
	CP	W1, [W0]
	BRA GT	L__RenderScreen231
	GOTO	L_RenderScreen63
L__RenderScreen231:
;minisub_main.c,611 :: 		clear_sub.left =  sub.x;
	MOV	_sub, W0
	MOV	W0, _clear_sub+2
;minisub_main.c,612 :: 		clear_sub.right =  sub.x+PLAYER_WIDTH;
	MOV	#63, W1
	MOV	#lo_addr(_sub), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+6
;minisub_main.c,613 :: 		clear_sub.top = sub.prev_y;
	MOV	_sub+6, W0
	MOV	W0, _clear_sub
;minisub_main.c,614 :: 		clear_sub.bottom =  sub.y;
	MOV	_sub+2, W0
	MOV	W0, _clear_sub+4
;minisub_main.c,615 :: 		}
L_RenderScreen63:
;minisub_main.c,618 :: 		if(sub.y < sub.prev_y){
	MOV	_sub+2, W1
	MOV	#lo_addr(_sub+6), W0
	CP	W1, [W0]
	BRA LT	L__RenderScreen232
	GOTO	L_RenderScreen64
L__RenderScreen232:
;minisub_main.c,619 :: 		clear_sub.left =  sub.x;
	MOV	_sub, W0
	MOV	W0, _clear_sub+2
;minisub_main.c,620 :: 		clear_sub.right =  sub.x+PLAYER_WIDTH;
	MOV	#63, W1
	MOV	#lo_addr(_sub), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+6
;minisub_main.c,621 :: 		clear_sub.top = sub.y + PLAYER_HEIGHT;
	MOV	#47, W1
	MOV	#lo_addr(_sub+2), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub
;minisub_main.c,622 :: 		clear_sub.bottom = sub.prev_y + PLAYER_HEIGHT;
	MOV	#47, W1
	MOV	#lo_addr(_sub+6), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+4
;minisub_main.c,623 :: 		}
L_RenderScreen64:
;minisub_main.c,627 :: 		if (clear_sub.left <=0)
	MOV	_clear_sub+2, W0
	CP	W0, #0
	BRA LE	L__RenderScreen233
	GOTO	L_RenderScreen65
L__RenderScreen233:
;minisub_main.c,628 :: 		clear_sub.left = 0;
	CLR	W0
	MOV	W0, _clear_sub+2
L_RenderScreen65:
;minisub_main.c,631 :: 		if (clear_sub.top <= STATUS_TEXT_CELL_HEIGHT)
	MOV	_clear_sub, W0
	CP	W0, #25
	BRA LE	L__RenderScreen234
	GOTO	L_RenderScreen66
L__RenderScreen234:
;minisub_main.c,632 :: 		clear_sub.top = STATUS_TEXT_CELL_HEIGHT;
	MOV	#25, W0
	MOV	W0, _clear_sub
L_RenderScreen66:
;minisub_main.c,635 :: 		clear_torpedo.left = torpedo.prev_x-1;
	MOV	_torpedo+8, W0
	SUB	W0, #1, W2
	MOV	W2, _clear_torpedo+2
;minisub_main.c,636 :: 		clear_torpedo.top =  torpedo.prev_y-1;
	MOV	_torpedo+10, W0
	DEC	W0
	MOV	W0, _clear_torpedo
;minisub_main.c,637 :: 		clear_torpedo.right =  torpedo.x;
	MOV	_torpedo+4, W0
	MOV	W0, _clear_torpedo+6
;minisub_main.c,638 :: 		clear_torpedo.bottom =  torpedo.y+torpedo.height+1;
	MOV	_torpedo+6, W1
	MOV	#lo_addr(_torpedo+2), W0
	ADD	W1, [W0], W0
	INC	W0
	MOV	W0, _clear_torpedo+4
;minisub_main.c,642 :: 		if (clear_torpedo.left <=0)
	CP	W2, #0
	BRA LE	L__RenderScreen235
	GOTO	L_RenderScreen67
L__RenderScreen235:
;minisub_main.c,643 :: 		clear_torpedo.left = 0;
	CLR	W0
	MOV	W0, _clear_torpedo+2
L_RenderScreen67:
;minisub_main.c,645 :: 		if (clear_torpedo.top <=0)
	MOV	_clear_torpedo, W0
	CP	W0, #0
	BRA LE	L__RenderScreen236
	GOTO	L_RenderScreen68
L__RenderScreen236:
;minisub_main.c,646 :: 		clear_torpedo.top = 0;
	CLR	W0
	MOV	W0, _clear_torpedo
L_RenderScreen68:
;minisub_main.c,650 :: 		clear_bonus_block.top =  bonus_block.prev_y;
	MOV	_bonus_block+10, W0
	MOV	W0, _clear_bonus_block
;minisub_main.c,651 :: 		if(clear_bonus_block.top < 0)
	MOV	_bonus_block+10, W0
	CP	W0, #0
	BRA LT	L__RenderScreen237
	GOTO	L_RenderScreen69
L__RenderScreen237:
;minisub_main.c,652 :: 		clear_bonus_block.top = 0;
	CLR	W0
	MOV	W0, _clear_bonus_block
L_RenderScreen69:
;minisub_main.c,654 :: 		clear_bonus_block.left =  bonus_block.x + bonus_block.width;
	MOV	_bonus_block+4, W1
	MOV	#lo_addr(_bonus_block), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_bonus_block+2
;minisub_main.c,655 :: 		if(clear_bonus_block.left < 0)
	CP	W0, #0
	BRA LT	L__RenderScreen238
	GOTO	L_RenderScreen70
L__RenderScreen238:
;minisub_main.c,656 :: 		clear_bonus_block.left = 0;
	CLR	W0
	MOV	W0, _clear_bonus_block+2
L_RenderScreen70:
;minisub_main.c,658 :: 		clear_bonus_block.right = bonus_block.prev_x + bonus_block.width;
	MOV	_bonus_block+8, W1
	MOV	#lo_addr(_bonus_block), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_bonus_block+6
;minisub_main.c,659 :: 		if(clear_bonus_block.right < 0)
	CP	W0, #0
	BRA LT	L__RenderScreen239
	GOTO	L_RenderScreen71
L__RenderScreen239:
;minisub_main.c,660 :: 		clear_bonus_block.right = 0;
	CLR	W0
	MOV	W0, _clear_bonus_block+6
L_RenderScreen71:
;minisub_main.c,662 :: 		clear_bonus_block.bottom = bonus_block.prev_y + bonus_block.height;
	MOV	_bonus_block+10, W1
	MOV	#lo_addr(_bonus_block+2), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_bonus_block+4
;minisub_main.c,663 :: 		if(clear_bonus_block.bottom < 0)
	CP	W0, #0
	BRA LT	L__RenderScreen240
	GOTO	L_RenderScreen72
L__RenderScreen240:
;minisub_main.c,664 :: 		clear_bonus_block.bottom = 0;
	CLR	W0
	MOV	W0, _clear_bonus_block+4
L_RenderScreen72:
;minisub_main.c,672 :: 		TFT_Set_Brush(1, bgColor, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
	CLR	W13
	CLR	W12
	MOV	_bgColor, W11
	MOV	#1, W10
	CLR	W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;minisub_main.c,675 :: 		if( (sub.prev_x != sub.x)|| (sub.prev_y != sub.y) || (sub.x < (0)) || (sub.y < (STATUS_TEXT_CELL_HEIGHT)) ){
	MOV	_sub+4, W1
	MOV	#lo_addr(_sub), W0
	CP	W1, [W0]
	BRA Z	L__RenderScreen241
	GOTO	L__RenderScreen168
L__RenderScreen241:
	MOV	_sub+6, W1
	MOV	#lo_addr(_sub+2), W0
	CP	W1, [W0]
	BRA Z	L__RenderScreen242
	GOTO	L__RenderScreen167
L__RenderScreen242:
	MOV	_sub, W0
	CP	W0, #0
	BRA GE	L__RenderScreen243
	GOTO	L__RenderScreen166
L__RenderScreen243:
	MOV	_sub+2, W0
	CP	W0, #25
	BRA GE	L__RenderScreen244
	GOTO	L__RenderScreen165
L__RenderScreen244:
	GOTO	L_RenderScreen75
L__RenderScreen168:
L__RenderScreen167:
L__RenderScreen166:
L__RenderScreen165:
;minisub_main.c,677 :: 		TFT_Rectangle(clear_sub.left, clear_sub.top, clear_sub.right, clear_sub.bottom);
	MOV	_clear_sub+4, W13
	MOV	_clear_sub+6, W12
	MOV	_clear_sub, W11
	MOV	_clear_sub+2, W10
	CALL	_TFT_Rectangle
;minisub_main.c,678 :: 		}
L_RenderScreen75:
;minisub_main.c,681 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
; mine_inc start address is: 8 (W4)
	CLR	W4
; mine_inc end address is: 8 (W4)
L_RenderScreen76:
; mine_inc start address is: 8 (W4)
	CP	W4, #3
	BRA LE	L__RenderScreen245
	GOTO	L_RenderScreen77
L__RenderScreen245:
;minisub_main.c,682 :: 		TFT_Rectangle( clear_mine[mine_inc].left, clear_mine[mine_inc].top, clear_mine[mine_inc].right, clear_mine[mine_inc].bottom);
	SL	W4, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #4, W3
	ADD	W0, #6, W2
	MOV	[W0], W1
	INC2	W0
	PUSH	W4
	MOV	[W3], W13
	MOV	[W2], W12
	MOV	W1, W11
	MOV	[W0], W10
	CALL	_TFT_Rectangle
	POP	W4
;minisub_main.c,681 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	INC	W4
;minisub_main.c,683 :: 		}
; mine_inc end address is: 8 (W4)
	GOTO	L_RenderScreen76
L_RenderScreen77:
;minisub_main.c,686 :: 		if(bonus_block.x <= SCREEN_WIDTH){
	MOV	_bonus_block+4, W1
	MOV	#320, W0
	CP	W1, W0
	BRA LE	L__RenderScreen246
	GOTO	L_RenderScreen79
L__RenderScreen246:
;minisub_main.c,688 :: 		TFT_Rectangle( clear_bonus_block.left, clear_bonus_block.top, clear_bonus_block.right, clear_bonus_block.bottom);
	MOV	_clear_bonus_block+4, W13
	MOV	_clear_bonus_block+6, W12
	MOV	_clear_bonus_block, W11
	MOV	_clear_bonus_block+2, W10
	CALL	_TFT_Rectangle
;minisub_main.c,689 :: 		}
L_RenderScreen79:
;minisub_main.c,693 :: 		if(fire_torpedo_flag){
	MOV	#lo_addr(_fire_torpedo_flag), W0
	CP0	[W0]
	BRA NZ	L__RenderScreen247
	GOTO	L_RenderScreen80
L__RenderScreen247:
;minisub_main.c,697 :: 		TFT_Rectangle( clear_torpedo.left, clear_torpedo.top, clear_torpedo.right, clear_torpedo.bottom);
	MOV	_clear_torpedo+4, W13
	MOV	_clear_torpedo+6, W12
	MOV	_clear_torpedo, W11
	MOV	_clear_torpedo+2, W10
	CALL	_TFT_Rectangle
;minisub_main.c,698 :: 		}
L_RenderScreen80:
;minisub_main.c,701 :: 		TFT_Set_Brush(1, bgColor, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
	CLR	W13
	CLR	W12
	MOV	_bgColor, W11
	MOV	#1, W10
	CLR	W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;minisub_main.c,710 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
; mine_inc start address is: 12 (W6)
	CLR	W6
; mine_inc end address is: 12 (W6)
L_RenderScreen81:
; mine_inc start address is: 12 (W6)
	CP	W6, #3
	BRA LE	L__RenderScreen248
	GOTO	L_RenderScreen82
L__RenderScreen248:
;minisub_main.c,711 :: 		TFT_Image(mine[mine_inc].x, mine[mine_inc].y, mine_bmp, 1);
	MOV	#lo_addr(_mine_bmp), W4
	MOV	#higher_addr(_mine_bmp), W5
	MOV	#14, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	PUSH	W6
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
	POP	W6
;minisub_main.c,710 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	INC	W6
;minisub_main.c,712 :: 		}
; mine_inc end address is: 12 (W6)
	GOTO	L_RenderScreen81
L_RenderScreen82:
;minisub_main.c,715 :: 		if(bonus_block.x <= SCREEN_WIDTH){
	MOV	_bonus_block+4, W1
	MOV	#320, W0
	CP	W1, W0
	BRA LE	L__RenderScreen249
	GOTO	L_RenderScreen84
L__RenderScreen249:
;minisub_main.c,718 :: 		if(bonus_type == 2) {
	MOV	_bonus_type, W0
	CP	W0, #2
	BRA Z	L__RenderScreen250
	GOTO	L_RenderScreen85
L__RenderScreen250:
;minisub_main.c,720 :: 		TFT_Image(bonus_block.x, bonus_block.y, heart_bmp, 1);
	MOV	#lo_addr(_heart_bmp), W0
	MOV	#higher_addr(_heart_bmp), W1
	MOV.D	W0, W12
	MOV	_bonus_block+6, W11
	MOV	_bonus_block+4, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,721 :: 		}
	GOTO	L_RenderScreen86
L_RenderScreen85:
;minisub_main.c,724 :: 		TFT_Image(bonus_block.x, bonus_block.y, torpedo_pack_bmp, 1);
	MOV	#lo_addr(_torpedo_pack_bmp), W0
	MOV	#higher_addr(_torpedo_pack_bmp), W1
	MOV.D	W0, W12
	MOV	_bonus_block+6, W11
	MOV	_bonus_block+4, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,725 :: 		}
L_RenderScreen86:
;minisub_main.c,726 :: 		}
L_RenderScreen84:
;minisub_main.c,729 :: 		if(fire_torpedo_flag){
	MOV	#lo_addr(_fire_torpedo_flag), W0
	CP0	[W0]
	BRA NZ	L__RenderScreen251
	GOTO	L_RenderScreen87
L__RenderScreen251:
;minisub_main.c,730 :: 		TFT_Image(torpedo.x, torpedo.y, torpedo_bmp, 1);
	MOV	#lo_addr(_torpedo_bmp), W0
	MOV	#higher_addr(_torpedo_bmp), W1
	MOV.D	W0, W12
	MOV	_torpedo+6, W11
	MOV	_torpedo+4, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,731 :: 		}
L_RenderScreen87:
;minisub_main.c,735 :: 		TFT_Image(sub.x, sub.y, sub_bmp, 1);
	MOV	#lo_addr(_sub_bmp), W0
	MOV	#higher_addr(_sub_bmp), W1
	MOV.D	W0, W12
	MOV	_sub+2, W11
	MOV	_sub, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,742 :: 		if( (sub.prev_x != sub.x)|| (sub.prev_y != sub.y) || (sub.x < (0)) || (sub.y < (STATUS_TEXT_CELL_HEIGHT)) ){
	MOV	_sub+4, W1
	MOV	#lo_addr(_sub), W0
	CP	W1, [W0]
	BRA Z	L__RenderScreen252
	GOTO	L__RenderScreen172
L__RenderScreen252:
	MOV	_sub+6, W1
	MOV	#lo_addr(_sub+2), W0
	CP	W1, [W0]
	BRA Z	L__RenderScreen253
	GOTO	L__RenderScreen171
L__RenderScreen253:
	MOV	_sub, W0
	CP	W0, #0
	BRA GE	L__RenderScreen254
	GOTO	L__RenderScreen170
L__RenderScreen254:
	MOV	_sub+2, W0
	CP	W0, #25
	BRA GE	L__RenderScreen255
	GOTO	L__RenderScreen169
L__RenderScreen255:
	GOTO	L_RenderScreen90
L__RenderScreen172:
L__RenderScreen171:
L__RenderScreen170:
L__RenderScreen169:
;minisub_main.c,744 :: 		TFT_Rectangle(clear_sub.left, clear_sub.top, clear_sub.right, clear_sub.bottom);
	MOV	_clear_sub+4, W13
	MOV	_clear_sub+6, W12
	MOV	_clear_sub, W11
	MOV	_clear_sub+2, W10
	CALL	_TFT_Rectangle
;minisub_main.c,745 :: 		}
L_RenderScreen90:
;minisub_main.c,749 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
; mine_inc start address is: 10 (W5)
	CLR	W5
; mine_inc end address is: 10 (W5)
L_RenderScreen91:
; mine_inc start address is: 10 (W5)
	CP	W5, #3
	BRA LE	L__RenderScreen256
	GOTO	L_RenderScreen92
L__RenderScreen256:
;minisub_main.c,751 :: 		if(IsCollision(sub.x, sub.y, PLAYER_WIDTH, PLAYER_HEIGHT, mine[mine_inc].x, mine[mine_inc].y, mine[mine_inc].width, mine[mine_inc].height)) {
	MOV	#14, W0
	MUL.UU	W0, W5, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W4
	ADD	W4, #2, W3
	MOV	[W4], W2
	ADD	W4, #6, W0
	MOV	[W0], W1
	ADD	W4, #4, W0
	MOV	[W0], W0
	MOV	#47, W13
	MOV	#63, W12
	MOV	_sub+2, W11
	MOV	_sub, W10
	PUSH	[W3]
	PUSH	W2
	PUSH	W1
	PUSH	W0
	CALL	_IsCollision
	SUB	#8, W15
	CP0.B	W0
	BRA NZ	L__RenderScreen257
	GOTO	L_RenderScreen94
L__RenderScreen257:
;minisub_main.c,753 :: 		mineHit = 1;
	MOV	#1, W0
	MOV	W0, _mineHit
;minisub_main.c,756 :: 		destroyed_mine_id = mine_inc;
	MOV	W5, _destroyed_mine_id
;minisub_main.c,759 :: 		UART2_Write_Text("You hit a sea mine!");
	MOV	#lo_addr(?lstr12_minisub_main), W10
	CALL	_UART2_Write_Text
;minisub_main.c,762 :: 		}
L_RenderScreen94:
;minisub_main.c,764 :: 		if(fire_torpedo_flag){
	MOV	#lo_addr(_fire_torpedo_flag), W0
	CP0	[W0]
	BRA NZ	L__RenderScreen258
	GOTO	L_RenderScreen95
L__RenderScreen258:
;minisub_main.c,766 :: 		if(IsCollision(torpedo.x, torpedo.y, torpedo.width, torpedo.height, mine[mine_inc].x, mine[mine_inc].y, mine[mine_inc].width, mine[mine_inc].height)) {
	MOV	#14, W0
	MUL.UU	W0, W5, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W4
	ADD	W4, #2, W3
	MOV	[W4], W2
	ADD	W4, #6, W0
	MOV	[W0], W1
	ADD	W4, #4, W0
	MOV	[W0], W0
	MOV	_torpedo+2, W13
	MOV	_torpedo, W12
	MOV	_torpedo+6, W11
	MOV	_torpedo+4, W10
	PUSH	[W3]
	PUSH	W2
	PUSH	W1
	PUSH	W0
	CALL	_IsCollision
	SUB	#8, W15
	CP0.B	W0
	BRA NZ	L__RenderScreen259
	GOTO	L_RenderScreen96
L__RenderScreen259:
;minisub_main.c,768 :: 		mineExplode = 1;
	MOV	#1, W0
	MOV	W0, _mineExplode
;minisub_main.c,771 :: 		destroyed_mine_id = mine_inc;
	MOV	W5, _destroyed_mine_id
;minisub_main.c,774 :: 		UART2_Write_Text("Your torpedo destroyed a sea mine!");
	MOV	#lo_addr(?lstr13_minisub_main), W10
	CALL	_UART2_Write_Text
;minisub_main.c,777 :: 		}
L_RenderScreen96:
;minisub_main.c,778 :: 		}
L_RenderScreen95:
;minisub_main.c,749 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	INC	W5
;minisub_main.c,782 :: 		}
; mine_inc end address is: 10 (W5)
	GOTO	L_RenderScreen91
L_RenderScreen92:
;minisub_main.c,786 :: 		if(IsCollision(sub.x, sub.y, PLAYER_WIDTH, PLAYER_HEIGHT, bonus_block.x, bonus_block.y, bonus_block.width, bonus_block.height)) {
	MOV	#47, W13
	MOV	#63, W12
	MOV	_sub+2, W11
	MOV	_sub, W10
	PUSH	_bonus_block+2
	PUSH	_bonus_block
	PUSH	_bonus_block+6
	PUSH	_bonus_block+4
	CALL	_IsCollision
	SUB	#8, W15
	CP0.B	W0
	BRA NZ	L__RenderScreen260
	GOTO	L_RenderScreen97
L__RenderScreen260:
;minisub_main.c,789 :: 		bonus_id = 1;
	MOV	#1, W0
	MOV	W0, _bonus_id
;minisub_main.c,792 :: 		if(bonus_type == 2){
	MOV	_bonus_type, W0
	CP	W0, #2
	BRA Z	L__RenderScreen261
	GOTO	L_RenderScreen98
L__RenderScreen261:
;minisub_main.c,794 :: 		subLives += 1;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,797 :: 		UART2_Write_Text("You picked up an extra life bonus!");
	MOV	#lo_addr(?lstr14_minisub_main), W10
	CALL	_UART2_Write_Text
;minisub_main.c,798 :: 		}
	GOTO	L_RenderScreen99
L_RenderScreen98:
;minisub_main.c,801 :: 		torpedo_count += 3;
	MOV	#3, W1
	MOV	#lo_addr(_torpedo_count), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,804 :: 		UART2_Write_Text("You picked up a torpedo 3 pack bonus!");
	MOV	#lo_addr(?lstr15_minisub_main), W10
	CALL	_UART2_Write_Text
;minisub_main.c,805 :: 		}
L_RenderScreen99:
;minisub_main.c,809 :: 		ResetBonusBlock();
	CALL	_ResetBonusBlock
;minisub_main.c,812 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,813 :: 		}
L_RenderScreen97:
;minisub_main.c,818 :: 		if(mineHit){
	MOV	#lo_addr(_mineHit), W0
	CP0	[W0]
	BRA NZ	L__RenderScreen262
	GOTO	L_RenderScreen100
L__RenderScreen262:
;minisub_main.c,822 :: 		fireball.x = (sub.x + (PLAYER_WIDTH/2) ) - (fireball.width/2) ;
	MOV	_sub, W0
	ADD	W0, #31, W1
	MOV	_fireball, W0
	LSR	W0, #1, W0
	SUB	W1, W0, W2
	MOV	W2, _fireball+4
;minisub_main.c,823 :: 		fireball.y = (sub.y + (PLAYER_HEIGHT/2) ) - (fireball.height/2) ;
	MOV	_sub+2, W0
	ADD	W0, #23, W1
	MOV	_fireball+2, W0
	LSR	W0, #1, W0
	SUB	W1, W0, W0
	MOV	W0, _fireball+6
;minisub_main.c,826 :: 		if( fireball.x <=0)
	CP	W2, #0
	BRA LE	L__RenderScreen263
	GOTO	L_RenderScreen101
L__RenderScreen263:
;minisub_main.c,827 :: 		fireball.x=0;
	CLR	W0
	MOV	W0, _fireball+4
L_RenderScreen101:
;minisub_main.c,829 :: 		if( fireball.y <= STATUS_TEXT_CELL_HEIGHT)
	MOV	_fireball+6, W0
	CP	W0, #25
	BRA LE	L__RenderScreen264
	GOTO	L_RenderScreen102
L__RenderScreen264:
;minisub_main.c,830 :: 		fireball.y = STATUS_TEXT_CELL_HEIGHT;
	MOV	#25, W0
	MOV	W0, _fireball+6
L_RenderScreen102:
;minisub_main.c,845 :: 		TFT_Image(fireball.x, fireball.y, fireball_bmp, 1);
	MOV	#lo_addr(_fireball_bmp), W0
	MOV	#higher_addr(_fireball_bmp), W1
	MOV.D	W0, W12
	MOV	_fireball+6, W11
	MOV	_fireball+4, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,848 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,850 :: 		}
L_RenderScreen100:
;minisub_main.c,855 :: 		if(mineExplode){
	MOV	#lo_addr(_mineExplode), W0
	CP0	[W0]
	BRA NZ	L__RenderScreen265
	GOTO	L_RenderScreen103
L__RenderScreen265:
;minisub_main.c,863 :: 		clear_torpedo.left = torpedo.x;
	MOV	_torpedo+4, W0
	MOV	W0, _clear_torpedo+2
;minisub_main.c,864 :: 		clear_torpedo.top =  torpedo.y;
	MOV	_torpedo+6, W0
	MOV	W0, _clear_torpedo
;minisub_main.c,865 :: 		clear_torpedo.right =  torpedo.x+torpedo.width;
	MOV	_torpedo+4, W1
	MOV	#lo_addr(_torpedo), W0
	ADD	W1, [W0], W2
	MOV	W2, _clear_torpedo+6
;minisub_main.c,866 :: 		clear_torpedo.bottom =  torpedo.y+torpedo.height;
	MOV	_torpedo+6, W1
	MOV	#lo_addr(_torpedo+2), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_torpedo+4
;minisub_main.c,869 :: 		TFT_Rectangle( clear_torpedo.left, clear_torpedo.top, clear_torpedo.right, clear_torpedo.bottom);
	MOV	W0, W13
	MOV	W2, W12
	MOV	_torpedo+6, W11
	MOV	_torpedo+4, W10
	CALL	_TFT_Rectangle
;minisub_main.c,872 :: 		explode.x = (mine[destroyed_mine_id].x + (mine[destroyed_mine_id].width/2) ) - (explode.width/2) ;
	MOV	#14, W1
	MOV	#lo_addr(_destroyed_mine_id), W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W3
	ADD	W3, #4, W0
	MOV	[W0], W1
	MOV	[W3], W0
	LSR	W0, #1, W0
	ADD	W1, W0, W1
	MOV	_explode, W0
	LSR	W0, #1, W0
	SUB	W1, W0, W2
	MOV	W2, _explode+4
;minisub_main.c,873 :: 		explode.y = (mine[destroyed_mine_id].y + (mine[destroyed_mine_id].height/2) ) - (explode.height/2);
	ADD	W3, #6, W0
	MOV	[W0], W1
	ADD	W3, #2, W0
	MOV	[W0], W0
	LSR	W0, #1, W0
	ADD	W1, W0, W1
	MOV	_explode+2, W0
	LSR	W0, #1, W0
	SUB	W1, W0, W0
	MOV	W0, _explode+6
;minisub_main.c,876 :: 		if( explode.x <=0 ){
	CP	W2, #0
	BRA LE	L__RenderScreen266
	GOTO	L_RenderScreen104
L__RenderScreen266:
;minisub_main.c,877 :: 		explode.x=0;
	CLR	W0
	MOV	W0, _explode+4
;minisub_main.c,878 :: 		}
L_RenderScreen104:
;minisub_main.c,880 :: 		if( explode.y <= STATUS_TEXT_CELL_HEIGHT){
	MOV	_explode+6, W0
	CP	W0, #25
	BRA LE	L__RenderScreen267
	GOTO	L_RenderScreen105
L__RenderScreen267:
;minisub_main.c,881 :: 		explode.y = STATUS_TEXT_CELL_HEIGHT;
	MOV	#25, W0
	MOV	W0, _explode+6
;minisub_main.c,882 :: 		}
L_RenderScreen105:
;minisub_main.c,885 :: 		TFT_Image(explode.x, explode.y, explode_bmp, 1);
	MOV	#lo_addr(_explode_bmp), W0
	MOV	#higher_addr(_explode_bmp), W1
	MOV.D	W0, W12
	MOV	_explode+6, W11
	MOV	_explode+4, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,886 :: 		Delay_ms(100);
	MOV	#17, W8
	MOV	#18095, W7
L_RenderScreen106:
	DEC	W7
	BRA NZ	L_RenderScreen106
	DEC	W8
	BRA NZ	L_RenderScreen106
;minisub_main.c,889 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,893 :: 		mineExplode = 0;
	CLR	W0
	MOV	W0, _mineExplode
;minisub_main.c,896 :: 		fire_torpedo_flag = 0;
	CLR	W0
	MOV	W0, _fire_torpedo_flag
;minisub_main.c,899 :: 		torpedo.x = 0;
	CLR	W0
	MOV	W0, _torpedo+4
;minisub_main.c,900 :: 		torpedo.y = 0;
	CLR	W0
	MOV	W0, _torpedo+6
;minisub_main.c,901 :: 		torpedo.prev_x = 0;
	CLR	W0
	MOV	W0, _torpedo+8
;minisub_main.c,902 :: 		torpedo.prev_y = 0;
	CLR	W0
	MOV	W0, _torpedo+10
;minisub_main.c,906 :: 		ResetSeaMine(destroyed_mine_id);
	MOV	_destroyed_mine_id, W10
	CALL	_ResetSeaMine
;minisub_main.c,907 :: 		mine[destroyed_mine_id].prev_x = mine[destroyed_mine_id].x;
	MOV	#14, W1
	MOV	#lo_addr(_destroyed_mine_id), W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #8, W1
	ADD	W0, #4, W0
	MOV	[W0], [W1]
;minisub_main.c,910 :: 		score += 50;
	MOV	#50, W1
	MOV	#lo_addr(_score), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,911 :: 		}
L_RenderScreen103:
;minisub_main.c,915 :: 		if( (level == 1) && (score > 1000) ){
	MOV	_level, W0
	CP	W0, #1
	BRA Z	L__RenderScreen268
	GOTO	L__RenderScreen174
L__RenderScreen268:
	MOV	_score, W1
	MOV	#1000, W0
	CP	W1, W0
	BRA GT	L__RenderScreen269
	GOTO	L__RenderScreen173
L__RenderScreen269:
L__RenderScreen162:
;minisub_main.c,916 :: 		level = 2;
	MOV	#2, W0
	MOV	W0, _level
;minisub_main.c,917 :: 		prev_level = level-1;
	MOV	#1, W0
	MOV	W0, _prev_level
;minisub_main.c,920 :: 		mine_speed = 8;
	MOV	#8, W0
	MOV	W0, _mine_speed
;minisub_main.c,923 :: 		bonus_factor = 1;
	MOV	#1, W0
	MOV	W0, _bonus_factor
;minisub_main.c,915 :: 		if( (level == 1) && (score > 1000) ){
L__RenderScreen174:
L__RenderScreen173:
;minisub_main.c,926 :: 		if( (level == 2) && (score > 2500) ){
	MOV	_level, W0
	CP	W0, #2
	BRA Z	L__RenderScreen270
	GOTO	L__RenderScreen176
L__RenderScreen270:
	MOV	_score, W1
	MOV	#2500, W0
	CP	W1, W0
	BRA GT	L__RenderScreen271
	GOTO	L__RenderScreen175
L__RenderScreen271:
L__RenderScreen161:
;minisub_main.c,927 :: 		level = 3;
	MOV	#3, W0
	MOV	W0, _level
;minisub_main.c,928 :: 		prev_level = level-1;
	MOV	#2, W0
	MOV	W0, _prev_level
;minisub_main.c,931 :: 		mine_speed = 9;
	MOV	#9, W0
	MOV	W0, _mine_speed
;minisub_main.c,934 :: 		bonus_factor = 2;
	MOV	#2, W0
	MOV	W0, _bonus_factor
;minisub_main.c,926 :: 		if( (level == 2) && (score > 2500) ){
L__RenderScreen176:
L__RenderScreen175:
;minisub_main.c,937 :: 		if( (level == 3) && (score > 5000) ){
	MOV	_level, W0
	CP	W0, #3
	BRA Z	L__RenderScreen272
	GOTO	L__RenderScreen178
L__RenderScreen272:
	MOV	_score, W1
	MOV	#5000, W0
	CP	W1, W0
	BRA GT	L__RenderScreen273
	GOTO	L__RenderScreen177
L__RenderScreen273:
L__RenderScreen160:
;minisub_main.c,938 :: 		level = 4;
	MOV	#4, W0
	MOV	W0, _level
;minisub_main.c,939 :: 		prev_level = level-1;
	MOV	#3, W0
	MOV	W0, _prev_level
;minisub_main.c,942 :: 		mine_speed = 10;
	MOV	#10, W0
	MOV	W0, _mine_speed
;minisub_main.c,945 :: 		bonus_factor = 3;
	MOV	#3, W0
	MOV	W0, _bonus_factor
;minisub_main.c,937 :: 		if( (level == 3) && (score > 5000) ){
L__RenderScreen178:
L__RenderScreen177:
;minisub_main.c,948 :: 		if( (level == 4) && (score > 8000) ){
	MOV	_level, W0
	CP	W0, #4
	BRA Z	L__RenderScreen274
	GOTO	L__RenderScreen180
L__RenderScreen274:
	MOV	_score, W1
	MOV	#8000, W0
	CP	W1, W0
	BRA GT	L__RenderScreen275
	GOTO	L__RenderScreen179
L__RenderScreen275:
L__RenderScreen159:
;minisub_main.c,949 :: 		level = 5;
	MOV	#5, W0
	MOV	W0, _level
;minisub_main.c,950 :: 		prev_level = level-1;
	MOV	#4, W0
	MOV	W0, _prev_level
;minisub_main.c,953 :: 		mine_speed = 11;
	MOV	#11, W0
	MOV	W0, _mine_speed
;minisub_main.c,956 :: 		bonus_factor = 5;
	MOV	#5, W0
	MOV	W0, _bonus_factor
;minisub_main.c,948 :: 		if( (level == 4) && (score > 8000) ){
L__RenderScreen180:
L__RenderScreen179:
;minisub_main.c,959 :: 		if( (level == 5) && (score > 10000) ){
	MOV	_level, W0
	CP	W0, #5
	BRA Z	L__RenderScreen276
	GOTO	L__RenderScreen182
L__RenderScreen276:
	MOV	_score, W1
	MOV	#10000, W0
	CP	W1, W0
	BRA GT	L__RenderScreen277
	GOTO	L__RenderScreen181
L__RenderScreen277:
L__RenderScreen158:
;minisub_main.c,960 :: 		level = 6;
	MOV	#6, W0
	MOV	W0, _level
;minisub_main.c,961 :: 		prev_level = level-1;
	MOV	#5, W0
	MOV	W0, _prev_level
;minisub_main.c,964 :: 		mine_speed = 12;
	MOV	#12, W0
	MOV	W0, _mine_speed
;minisub_main.c,967 :: 		bonus_factor = 5;
	MOV	#5, W0
	MOV	W0, _bonus_factor
;minisub_main.c,970 :: 		subLives++;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,959 :: 		if( (level == 5) && (score > 10000) ){
L__RenderScreen182:
L__RenderScreen181:
;minisub_main.c,973 :: 		if( (level == 6) && (score > 12000) ){
	MOV	_level, W0
	CP	W0, #6
	BRA Z	L__RenderScreen278
	GOTO	L__RenderScreen184
L__RenderScreen278:
	MOV	_score, W1
	MOV	#12000, W0
	CP	W1, W0
	BRA GT	L__RenderScreen279
	GOTO	L__RenderScreen183
L__RenderScreen279:
L__RenderScreen157:
;minisub_main.c,974 :: 		level = 7;
	MOV	#7, W0
	MOV	W0, _level
;minisub_main.c,975 :: 		prev_level = level-1;
	MOV	#6, W0
	MOV	W0, _prev_level
;minisub_main.c,978 :: 		mine_speed = 14;
	MOV	#14, W0
	MOV	W0, _mine_speed
;minisub_main.c,981 :: 		bonus_factor = 4;
	MOV	#4, W0
	MOV	W0, _bonus_factor
;minisub_main.c,984 :: 		subLives++;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,973 :: 		if( (level == 6) && (score > 12000) ){
L__RenderScreen184:
L__RenderScreen183:
;minisub_main.c,987 :: 		if( (level == 7) && (score > 15000) ){
	MOV	_level, W0
	CP	W0, #7
	BRA Z	L__RenderScreen280
	GOTO	L__RenderScreen186
L__RenderScreen280:
	MOV	_score, W1
	MOV	#15000, W0
	CP	W1, W0
	BRA GT	L__RenderScreen281
	GOTO	L__RenderScreen185
L__RenderScreen281:
L__RenderScreen156:
;minisub_main.c,988 :: 		level = 8;
	MOV	#8, W0
	MOV	W0, _level
;minisub_main.c,989 :: 		prev_level = level-1;
	MOV	#7, W0
	MOV	W0, _prev_level
;minisub_main.c,992 :: 		mine_speed = 14;
	MOV	#14, W0
	MOV	W0, _mine_speed
;minisub_main.c,995 :: 		bonus_factor = 4;
	MOV	#4, W0
	MOV	W0, _bonus_factor
;minisub_main.c,998 :: 		subLives++;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,987 :: 		if( (level == 7) && (score > 15000) ){
L__RenderScreen186:
L__RenderScreen185:
;minisub_main.c,1001 :: 		if (prev_level != level){
	MOV	_prev_level, W1
	MOV	#lo_addr(_level), W0
	CP	W1, [W0]
	BRA NZ	L__RenderScreen282
	GOTO	L_RenderScreen129
L__RenderScreen282:
;minisub_main.c,1003 :: 		ShowNextLevel();
	CALL	_ShowNextLevel
;minisub_main.c,1004 :: 		}
L_RenderScreen129:
;minisub_main.c,1008 :: 		RenderScore();
	CALL	_RenderScore
;minisub_main.c,1010 :: 		}
L_end_RenderScreen:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _RenderScreen

_RenderScore:

;minisub_main.c,1013 :: 		void RenderScore(){
;minisub_main.c,1018 :: 		(prev_torpedo_count != torpedo_count) ||
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	MOV	_score, W1
	MOV	#lo_addr(_prev_score), W0
	CP	W1, [W0]
	BRA Z	L__RenderScore284
	GOTO	L__RenderScore155
L__RenderScore284:
	MOV	_prev_torpedo_count, W1
	MOV	#lo_addr(_torpedo_count), W0
	CP	W1, [W0]
	BRA Z	L__RenderScore285
	GOTO	L__RenderScore154
L__RenderScore285:
;minisub_main.c,1019 :: 		(prev_subLives != subLives) ){
	MOV	_prev_subLives, W1
	MOV	#lo_addr(_subLives), W0
	CP	W1, [W0]
	BRA Z	L__RenderScore286
	GOTO	L__RenderScore153
L__RenderScore286:
	GOTO	L_RenderScore132
;minisub_main.c,1018 :: 		(prev_torpedo_count != torpedo_count) ||
L__RenderScore155:
L__RenderScore154:
;minisub_main.c,1019 :: 		(prev_subLives != subLives) ){
L__RenderScore153:
;minisub_main.c,1025 :: 		TFT_Set_Brush(1, bgColor, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
	CLR	W13
	CLR	W12
	MOV	_bgColor, W11
	MOV	#1, W10
	CLR	W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;minisub_main.c,1028 :: 		TFT_Rectangle( 0, 0, 319, 25);
	MOV	#25, W13
	MOV	#319, W12
	CLR	W11
	CLR	W10
	CALL	_TFT_Rectangle
;minisub_main.c,1029 :: 		}
L_RenderScore132:
;minisub_main.c,1034 :: 		TFT_Image(5, 2, torpedos_remain_bmp, 1);
	MOV	#lo_addr(_torpedos_remain_bmp), W0
	MOV	#higher_addr(_torpedos_remain_bmp), W1
	MOV.D	W0, W12
	MOV	#2, W11
	MOV	#5, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1037 :: 		TFT_Image(270, 2, lives_bmp, 1);
	MOV	#lo_addr(_lives_bmp), W0
	MOV	#higher_addr(_lives_bmp), W1
	MOV.D	W0, W12
	MOV	#2, W11
	MOV	#270, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1041 :: 		IntToStr(level, level_text);
	MOV	#lo_addr(_level_text), W11
	MOV	_level, W10
	CALL	_IntToStr
;minisub_main.c,1044 :: 		IntToStr(subLives, lives_text);
	MOV	#lo_addr(_lives_text), W11
	MOV	_subLives, W10
	CALL	_IntToStr
;minisub_main.c,1047 :: 		IntToStr(torpedo_count, torpedoes_text);
	MOV	#lo_addr(_torpedoes_text), W11
	MOV	_torpedo_count, W10
	CALL	_IntToStr
;minisub_main.c,1050 :: 		IntToStr(score, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	_score, W10
	CALL	_IntToStr
;minisub_main.c,1054 :: 		TFT_Write_Text(lives_text, (270 + 20), 2);
	MOV	#2, W12
	MOV	#290, W11
	MOV	#lo_addr(_lives_text), W10
	CALL	_TFT_Write_Text
;minisub_main.c,1057 :: 		TFT_Write_Text(torpedoes_text, (5 + 41), 2);
	MOV	#2, W12
	MOV	#46, W11
	MOV	#lo_addr(_torpedoes_text), W10
	CALL	_TFT_Write_Text
;minisub_main.c,1060 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#___Lib_System_DefaultPage, W0
	MOV	W0, W11
	CALL	_TFT_Set_Font
;minisub_main.c,1063 :: 		strcpy(score_display_text, "Score: ");
	MOV	#lo_addr(?lstr16_minisub_main), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcpy
;minisub_main.c,1064 :: 		strcat(score_display_text, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcat
;minisub_main.c,1067 :: 		TFT_Write_Text(score_display_text, 120, 2);
	MOV	#2, W12
	MOV	#120, W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_TFT_Write_Text
;minisub_main.c,1073 :: 		}
L_end_RenderScore:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _RenderScore

_ResetGame:

;minisub_main.c,1076 :: 		void ResetGame(){
;minisub_main.c,1079 :: 		level = 1;
	MOV	#1, W0
	MOV	W0, _level
;minisub_main.c,1080 :: 		prev_level = 1;
	MOV	#1, W0
	MOV	W0, _prev_level
;minisub_main.c,1084 :: 		score = 0;
	CLR	W0
	MOV	W0, _score
;minisub_main.c,1087 :: 		bonus_factor = 1;
	MOV	#1, W0
	MOV	W0, _bonus_factor
;minisub_main.c,1090 :: 		mine_speed = 6;
	MOV	#6, W0
	MOV	W0, _mine_speed
;minisub_main.c,1093 :: 		torpedo_count = NUMBER_OF_TORPEDOES;
	MOV	#5, W0
	MOV	W0, _torpedo_count
;minisub_main.c,1096 :: 		subLives = NUMBER_OF_SUBMARINES;
	MOV	#3, W0
	MOV	W0, _subLives
;minisub_main.c,1099 :: 		bonus_counter = 0;
	CLR	W0
	MOV	W0, _bonus_counter
;minisub_main.c,1102 :: 		InitSprites();
	CALL	_InitSprites
;minisub_main.c,1103 :: 		}
L_end_ResetGame:
	RETURN
; end of _ResetGame

_InitSprites:
	LNK	#2

;minisub_main.c,1105 :: 		void InitSprites(){
;minisub_main.c,1106 :: 		int mine_inc = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;minisub_main.c,1110 :: 		torpedo_count = NUMBER_OF_TORPEDOES;
	MOV	#5, W0
	MOV	W0, _torpedo_count
;minisub_main.c,1113 :: 		fire_torpedo_flag = 0;
	CLR	W0
	MOV	W0, _fire_torpedo_flag
;minisub_main.c,1117 :: 		sub.x = 28;
	MOV	#28, W0
	MOV	W0, _sub
;minisub_main.c,1118 :: 		sub.y = 128;
	MOV	#128, W0
	MOV	W0, _sub+2
;minisub_main.c,1119 :: 		sub.prev_x = sub.x;
	MOV	#28, W0
	MOV	W0, _sub+4
;minisub_main.c,1120 :: 		sub.prev_y = sub.y;
	MOV	#128, W0
	MOV	W0, _sub+6
;minisub_main.c,1124 :: 		fireball.x = 0;
	CLR	W0
	MOV	W0, _fireball+4
;minisub_main.c,1125 :: 		fireball.y = 0;
	CLR	W0
	MOV	W0, _fireball+6
;minisub_main.c,1126 :: 		fireball.prev_x = 0;
	CLR	W0
	MOV	W0, _fireball+8
;minisub_main.c,1127 :: 		fireball.prev_y = 0;
	CLR	W0
	MOV	W0, _fireball+10
;minisub_main.c,1128 :: 		fireball.width = 130;
	MOV	#130, W0
	MOV	W0, _fireball
;minisub_main.c,1129 :: 		fireball.height = 134;
	MOV	#134, W0
	MOV	W0, _fireball+2
;minisub_main.c,1133 :: 		explode.x = 0;
	CLR	W0
	MOV	W0, _explode+4
;minisub_main.c,1134 :: 		explode.y = 0;
	CLR	W0
	MOV	W0, _explode+6
;minisub_main.c,1135 :: 		explode.prev_x = 0;
	CLR	W0
	MOV	W0, _explode+8
;minisub_main.c,1136 :: 		explode.prev_y = 0;
	CLR	W0
	MOV	W0, _explode+10
;minisub_main.c,1137 :: 		explode.width = 70;
	MOV	#70, W0
	MOV	W0, _explode
;minisub_main.c,1138 :: 		explode.height = 60;
	MOV	#60, W0
	MOV	W0, _explode+2
;minisub_main.c,1141 :: 		torpedo.x = 0;
	CLR	W0
	MOV	W0, _torpedo+4
;minisub_main.c,1142 :: 		torpedo.y = 0;
	CLR	W0
	MOV	W0, _torpedo+6
;minisub_main.c,1143 :: 		torpedo.prev_x = 0;
	CLR	W0
	MOV	W0, _torpedo+8
;minisub_main.c,1144 :: 		torpedo.prev_y = 0;
	CLR	W0
	MOV	W0, _torpedo+10
;minisub_main.c,1145 :: 		torpedo.visible = 1;
	MOV	#1, W0
	MOV	W0, _torpedo+12
;minisub_main.c,1146 :: 		torpedo.width = 35;
	MOV	#35, W0
	MOV	W0, _torpedo
;minisub_main.c,1147 :: 		torpedo.height = 14;
	MOV	#14, W0
	MOV	W0, _torpedo+2
;minisub_main.c,1150 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
; mine_inc start address is: 12 (W6)
	CLR	W6
; mine_inc end address is: 12 (W6)
L_InitSprites133:
; mine_inc start address is: 12 (W6)
	CP	W6, #3
	BRA LE	L__InitSprites289
	GOTO	L_InitSprites134
L__InitSprites289:
;minisub_main.c,1151 :: 		mine[mine_inc].x = (mine_inc * 90) + 200;
	MOV	#14, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #4, W1
	MOV	#90, W0
	MUL.SS	W6, W0, W2
	MOV	#200, W0
	ADD	W2, W0, W0
	MOV	W0, [W1]
;minisub_main.c,1152 :: 		mine[mine_inc].y = RandomHeightY();
	MOV	#14, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W0
	MOV	W0, [W14+0]
	CALL	_RandomHeightY
	MOV	[W14+0], W1
	MOV	W0, [W1]
;minisub_main.c,1154 :: 		mine[mine_inc].prev_x = mine[mine_inc].x ;
	MOV	#14, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #8, W1
	ADD	W0, #4, W0
	MOV	[W0], [W1]
;minisub_main.c,1155 :: 		mine[mine_inc].prev_y = mine[mine_inc].y ;
	MOV	#14, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W1
	ADD	W0, #6, W0
	MOV	[W0], [W1]
;minisub_main.c,1156 :: 		mine[mine_inc].width = 45;
	MOV	#14, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W1
	MOV	#45, W0
	MOV	W0, [W1]
;minisub_main.c,1157 :: 		mine[mine_inc].height = 45;
	MOV	#14, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #2, W1
	MOV	#45, W0
	MOV	W0, [W1]
;minisub_main.c,1150 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	INC	W6
;minisub_main.c,1158 :: 		}
; mine_inc end address is: 12 (W6)
	GOTO	L_InitSprites133
L_InitSprites134:
;minisub_main.c,1163 :: 		bonus_block.x = SCREEN_WIDTH*BONUS_SCREEN_SPACING;
	MOV	#640, W0
	MOV	W0, _bonus_block+4
;minisub_main.c,1164 :: 		bonus_block.y = RandomHeightY();  //generate random block Y position
	CALL	_RandomHeightY
	MOV	W0, _bonus_block+6
;minisub_main.c,1165 :: 		bonus_block.prev_x = 0;
	CLR	W0
	MOV	W0, _bonus_block+8
;minisub_main.c,1166 :: 		bonus_block.prev_y = 0;
	CLR	W0
	MOV	W0, _bonus_block+10
;minisub_main.c,1167 :: 		bonus_block.visible = 1;
	MOV	#1, W0
	MOV	W0, _bonus_block+12
;minisub_main.c,1168 :: 		bonus_block.width = 45;
	MOV	#45, W0
	MOV	W0, _bonus_block
;minisub_main.c,1169 :: 		bonus_block.height = 45;
	MOV	#45, W0
	MOV	W0, _bonus_block+2
;minisub_main.c,1172 :: 		bonus_type = 1;
	MOV	#1, W0
	MOV	W0, _bonus_type
;minisub_main.c,1175 :: 		TFT_Set_Pen(bgColor, 1);
	MOV	#1, W11
	MOV	_bgColor, W10
	CALL	_TFT_Set_Pen
;minisub_main.c,1178 :: 		TFT_Set_Brush(1, bgColor, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
	CLR	W13
	CLR	W12
	MOV	_bgColor, W11
	MOV	#1, W10
	CLR	W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;minisub_main.c,1181 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,1183 :: 		}
L_end_InitSprites:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _InitSprites

_SavePreviousVal:

;minisub_main.c,1186 :: 		void SavePreviousVal(){
;minisub_main.c,1187 :: 		int mine_inc = 0;
;minisub_main.c,1190 :: 		prev_score = score;
	MOV	_score, W0
	MOV	W0, _prev_score
;minisub_main.c,1193 :: 		sub.prev_x = sub.x;
	MOV	_sub, W0
	MOV	W0, _sub+4
;minisub_main.c,1194 :: 		sub.prev_y = sub.y;
	MOV	_sub+2, W0
	MOV	W0, _sub+6
;minisub_main.c,1197 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
; mine_inc start address is: 8 (W4)
	CLR	W4
; mine_inc end address is: 8 (W4)
L_SavePreviousVal136:
; mine_inc start address is: 8 (W4)
	CP	W4, #3
	BRA LE	L__SavePreviousVal291
	GOTO	L_SavePreviousVal137
L__SavePreviousVal291:
;minisub_main.c,1198 :: 		mine[mine_inc].prev_x = mine[mine_inc].x;
	MOV	#14, W0
	MUL.UU	W0, W4, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #8, W1
	ADD	W0, #4, W0
	MOV	[W0], [W1]
;minisub_main.c,1199 :: 		mine[mine_inc].prev_y = mine[mine_inc].y;
	MOV	#14, W0
	MUL.UU	W0, W4, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W1
	ADD	W0, #6, W0
	MOV	[W0], [W1]
;minisub_main.c,1197 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	INC	W4
;minisub_main.c,1200 :: 		}
; mine_inc end address is: 8 (W4)
	GOTO	L_SavePreviousVal136
L_SavePreviousVal137:
;minisub_main.c,1203 :: 		torpedo.prev_x = torpedo.x;
	MOV	_torpedo+4, W0
	MOV	W0, _torpedo+8
;minisub_main.c,1204 :: 		torpedo.prev_y = torpedo.y;
	MOV	_torpedo+6, W0
	MOV	W0, _torpedo+10
;minisub_main.c,1207 :: 		bonus_block.prev_x = bonus_block.x;
	MOV	_bonus_block+4, W0
	MOV	W0, _bonus_block+8
;minisub_main.c,1208 :: 		bonus_block.prev_y = bonus_block.y;
	MOV	_bonus_block+6, W0
	MOV	W0, _bonus_block+10
;minisub_main.c,1211 :: 		prev_torpedo_count = torpedo_count;
	MOV	_torpedo_count, W0
	MOV	W0, _prev_torpedo_count
;minisub_main.c,1212 :: 		prev_subLives = subLives;
	MOV	_subLives, W0
	MOV	W0, _prev_subLives
;minisub_main.c,1215 :: 		destroyed_mine_id = -1;
	MOV	#65535, W0
	MOV	W0, _destroyed_mine_id
;minisub_main.c,1218 :: 		bonus_id = -1;
	MOV	#65535, W0
	MOV	W0, _bonus_id
;minisub_main.c,1221 :: 		prev_level = level;
	MOV	_level, W0
	MOV	W0, _prev_level
;minisub_main.c,1223 :: 		}
L_end_SavePreviousVal:
	RETURN
; end of _SavePreviousVal

_IsCollision:
	LNK	#0

;minisub_main.c,1228 :: 		unsigned int Bomb_Left, unsigned int Bomb_Top, unsigned int Bomb_Width, unsigned int Bomb_Height) {
;minisub_main.c,1232 :: 		if( ((Shape_X + Shape_Width) >= Bomb_Left )               &&              ((Shape_X) <= (Bomb_Left + Bomb_Width-1)) &&
; Bomb_Left start address is: 2 (W1)
	MOV	[W14-8], W1
; Bomb_Top start address is: 4 (W2)
	MOV	[W14-10], W2
; Bomb_Width start address is: 6 (W3)
	MOV	[W14-12], W3
; Bomb_Height start address is: 8 (W4)
	MOV	[W14-14], W4
	ADD	W10, W12, W0
	CP	W0, W1
	BRA GEU	L__IsCollision293
	GOTO	L__IsCollision151
L__IsCollision293:
	ADD	W1, W3, W0
; Bomb_Left end address is: 2 (W1)
; Bomb_Width end address is: 6 (W3)
	DEC	W0
	CP	W10, W0
	BRA LEU	L__IsCollision294
	GOTO	L__IsCollision150
L__IsCollision294:
;minisub_main.c,1237 :: 		((Shape_Y + Shape_Height) >= Bomb_Top )                   &&               ((Shape_Y) <= (Bomb_Top + Bomb_Height-1))  ) {
	ADD	W11, W13, W0
	CP	W0, W2
	BRA GEU	L__IsCollision295
	GOTO	L__IsCollision149
L__IsCollision295:
	ADD	W2, W4, W0
; Bomb_Top end address is: 4 (W2)
; Bomb_Height end address is: 8 (W4)
	DEC	W0
	CP	W11, W0
	BRA LEU	L__IsCollision296
	GOTO	L__IsCollision148
L__IsCollision296:
L__IsCollision147:
;minisub_main.c,1244 :: 		return 1;
	MOV.B	#1, W0
	GOTO	L_end_IsCollision
;minisub_main.c,1232 :: 		if( ((Shape_X + Shape_Width) >= Bomb_Left )               &&              ((Shape_X) <= (Bomb_Left + Bomb_Width-1)) &&
L__IsCollision151:
L__IsCollision150:
;minisub_main.c,1237 :: 		((Shape_Y + Shape_Height) >= Bomb_Top )                   &&               ((Shape_Y) <= (Bomb_Top + Bomb_Height-1))  ) {
L__IsCollision149:
L__IsCollision148:
;minisub_main.c,1250 :: 		return 0;
	CLR	W0
;minisub_main.c,1253 :: 		}
L_end_IsCollision:
	ULNK
	RETURN
; end of _IsCollision

_GetNextSong:

;minisub_main.c,1257 :: 		void GetNextSong(){
;minisub_main.c,1258 :: 		UART2_Write_Line("Switching to the next song.");
	PUSH	W10
	MOV	#lo_addr(?lstr17_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,1260 :: 		Load_MP3_File("Pavese.mp3");
	MOV	#lo_addr(?lstr18_minisub_main), W10
	CALL	_Load_MP3_File
;minisub_main.c,1278 :: 		if(current_pos < 10){
	MOV	_current_pos, W0
	MOV	_current_pos+2, W1
	CP	W0, #10
	CPB	W1, #0
	BRA LT	L__GetNextSong298
	GOTO	L_GetNextSong143
L__GetNextSong298:
;minisub_main.c,1279 :: 		PreRollSong();
	CALL	_PreRollSong
;minisub_main.c,1280 :: 		}
L_GetNextSong143:
;minisub_main.c,1282 :: 		}
L_end_GetNextSong:
	POP	W10
	RETURN
; end of _GetNextSong

_PreRollSong:
	LNK	#4

;minisub_main.c,1285 :: 		void PreRollSong(){
;minisub_main.c,1286 :: 		int roll = 0;
;minisub_main.c,1287 :: 		int roll_max = 100;
	MOV	#100, W0
	MOV	W0, [W14+2]
;minisub_main.c,1290 :: 		for(roll = 0; roll<=roll_max;roll++){
	CLR	W0
	MOV	W0, [W14+0]
L_PreRollSong144:
	MOV	[W14+0], W1
	ADD	W14, #2, W0
	CP	W1, [W0]
	BRA LE	L__PreRollSong300
	GOTO	L_PreRollSong145
L__PreRollSong300:
;minisub_main.c,1291 :: 		Play_MP3_Chunk();
	CALL	_Play_MP3_Chunk
;minisub_main.c,1290 :: 		for(roll = 0; roll<=roll_max;roll++){
	MOV	[W14+0], W1
	ADD	W14, #0, W0
	ADD	W1, #1, [W0]
;minisub_main.c,1292 :: 		}
	GOTO	L_PreRollSong144
L_PreRollSong145:
;minisub_main.c,1293 :: 		}
L_end_PreRollSong:
	ULNK
	RETURN
; end of _PreRollSong
